/* Turska Framework/UI library (Turs2)
 * Copyright 2003-2008 Jetro Lauha
 * All rights reserved.
 * Web: http://iki.fi/jetro/turska/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of EITHER:
 *   (1) The GNU Lesser General Public License as published by the Free
 *       Software Foundation; either version 2.1 of the License, or (at
 *       your option) any later version. The text of the GNU Lesser
 *       General Public License is included with this library in the
 *       file LICENSE-LGPL.txt.
 *   (2) The BSD-style license that is included with this library in
 *       the file LICENSE-BSD.txt.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files
 * LICENSE-LGPL.txt and LICENSE-BSD.txt for more details.
 *
 * $Id: T2VerticalStripBitmapFontIrr.h,v 1.1 2008-04-19 11:46:25 tonic Exp $
 * $Revision: 1.1 $
 */

#ifndef T2VERTICALSTRIPBITMAPFONTIRR_H_INCLUDED
#define T2VERTICALSTRIPBITMAPFONTIRR_H_INCLUDED


namespace turska
{
    //! Implementation of the Turska Font which uses Irrlicht.
    /*! \todo Implementation documentation with explanation of font image contents.
     */
    class VerticalStripBitmapFontIrr : public turska::VerticalStripBitmapFont
    {
    public:
    
        //! Constructs a new font object.
        /*! The alphaTraceMinAlpha parameter is minimum alpha value to be traced
         *  as a visible pixel. It is ignored if the image surface lacks alpha.
         */
        VerticalStripBitmapFontIrr(GraphicsIrr *graphics,
                                   const C8 *fileName,
                                   const C8 *fontString = NULL,
                                   UI8 alphaTraceMinAlpha = 16);
        virtual ~VerticalStripBitmapFontIrr();
    
        // From turska::Font:

        virtual bool init();
    
        virtual bool reload();
    
        virtual I32 getStringWidth(const C8 *string);
        virtual REAL getStringWidth(const C8 *string, REAL scale);

        virtual void drawString(I32 x, I32 y, const C8 *string,
                                UI32 flags = FA_DEFAULT,
                                const Color &color = Color(0xffffffff));
        virtual void drawString(REAL x, REAL y, const C8 *string,
                                UI32 flags = FA_DEFAULT, REAL scale = 1,
                                const Color &color = Color(0xffffffff));
    
    protected:
    
        GraphicsIrr *mGraphics;
    
        UI8 mAlphaTraceMinAlpha;

    }; // class VerticalStripBitmapFontIrr
} // namespace turska


#endif // !T2VERTICALSTRIPBITMAPFONTIRR_H_INCLUDED
