/* Turska Framework/UI library (Turs2)
 * Copyright 2003-2008 Jetro Lauha
 * All rights reserved.
 * Web: http://iki.fi/jetro/turska/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of EITHER:
 *   (1) The GNU Lesser General Public License as published by the Free
 *       Software Foundation; either version 2.1 of the License, or (at
 *       your option) any later version. The text of the GNU Lesser
 *       General Public License is included with this library in the
 *       file LICENSE-LGPL.txt.
 *   (2) The BSD-style license that is included with this library in
 *       the file LICENSE-BSD.txt.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files
 * LICENSE-LGPL.txt and LICENSE-BSD.txt for more details.
 *
 * $Id: Turs2.h,v 1.1 2008-04-19 11:46:25 tonic Exp $
 * $Revision: 1.1 $
 */

#ifndef TURS2_H_INCLUDED
#define TURS2_H_INCLUDED


#ifdef _MSC_VER
#pragma warning(disable:4786)
#undef strdup
#define strdup _strdup
#endif // _MSC_VER


#ifdef T2_USE_IRR
#include "irrlicht.h"
#endif // T2_USE_IRR

#include "T2Types.h"
#include "T2Image.h"
#include "T2Graphics.h"
#include "T2Font.h"

#ifndef T2_NO_VERTICALSTRIPBITMAPFONT
#include "T2VerticalStripBitmapFont.h"
#endif // !T2_NO_VERTICALSTRIPBITMAPFONT

#include "T2IMGUI.h"
#include "T2IMGUIButtonStyle.h"
#include "T2IMGUISliderStyle.h"
#include "T2IMGUIImageButtonStyle.h"
#include "T2IMGUIImageSliderStyle.h"


#ifdef T2_USE_SDLOPENGL
#include "T2ImageOpenGL.h"
#include "T2GraphicsOpenGLSDL.h"
#ifndef T2_NO_VERTICALSTRIPBITMAPFONT
#include "T2VerticalStripBitmapFontSDLOpenGL.h"
#endif // !T2_NO_VERTICALSTRIPBITMAPFONT
#endif // T2_USE_SDLOPENGL

#ifdef T2_USE_IRR
#include "T2ImageIrr.h"
#include "T2GraphicsIrr.h"
#ifndef T2_NO_VERTICALSTRIPBITMAPFONT
#include "T2VerticalStripBitmapFontIrr.h"
#endif // !T2_NO_VERTICALSTRIPBITMAPFONT
#endif // T2_USE_IRR

#ifdef T2_USE_SDL2D
/* SDL2D implementation was partially done for older Turska
 * version. The partial implementation has been more or less
 * updated to newer API, but it really hasn't been tested
 * at all. Try to use at your own risk. Submitting a fixed
 * and completed implementation to the project is of course
 * encouraged. :-)
 */
#error SDL2D implementation isn't completed or tested.
//#include "T2ImageSDL.h"
//#include "T2GraphicsSDL.h"
#endif // T2_USE_SDL2D


#endif // !TURS2_H_INCLUDED
